︠0ea3e338-2b39-4b6f-8016-0d24964bb6c4i︠
%hide
@interact
def gear_of_function(
func=input_box('log(x)', 'function', str),
rips=slider(0,1000,default=100,label='rips'),
minval=slider(0,1000,default=0, label='min radius'),
maxval=slider(0,10000,default=1000, label='max radius'), 
useder=checkbox(False, 'use derivate'),
plotfunc=checkbox(False, 'plot function')):
    var('x')
    f(x)=func
    if minval>maxval:
        print "min value is bigger than max value!!!"
    if useder:
        f(x)=derivative(f(x),x)
    strong_monotony=bool(f(x+1)>f(x)) or bool(f(x)>f(x+1))
    if not strong_monotony:
        print "no strong monotony!!!"
    step=2*pi/rips
    G=line([(0,0),(0,0)])
    for i in range(rips):
        val=i*step
        try:
            r=min(maxval,max(minval,f(val)))
            G+=line([(0,0),(r*cos(val),r*sin(val))])
        except:
            pass
    G.show(aspect_ratio=1)
    if plotfunc:
        plot(f(x))
︡1c409926-97ba-406c-a7f9-6b93ac0b725a︡{"html": ""}︡
